% Instance of Mervis DB 
mervisDB = MerbonDatabase('username', 'password', 'dbUrl');

% Time interval definition
from = localMatlab2utcMatlab(datenum(2017, 1, 1)); %1.1.2017 in utc
to = localMatlab2utcMatlab(datenum(2017, 31, 1)); %31.1.2017 in utc
samplePeriod = 5*60; % 5 minutes
outputTimeZone = 'Local'; % possible 'Local' or  'Utc' parameter;

% Specifying varibles to download
varKeys1 = {'DPGuid', '338E2882-D72B-4D17-A241-73E8BC30F458';...
            'StationName', 'XXXXXXX'}; % Keys definition of first variable
varKeys2 = {'DPGuid', 'CC80211D-3D29-4CC2-91A2-F69483D566B5';...
            'StationName', 'YYYYYYY'}; % Keys definition of second variable
 
variable1 = MerbonDbVariable(varKeys1); % Create MerbonDbVariable object from defined keys
variable2 = MerbonDbVariable(varKeys2);

arrayOfVarKeys = [variable1; variable2]; % array of MerbonDbVariables objects
 
% help for function getData
help MerbonDatabase.getData 

% Download required data
[data, time] = db.getData(arrayOfVarKeys, from, to, samplePeriod, outputTimeZone);

% Get all variables with defined keys
allVaribales = db.getAllVars(varKeys1);





