classdef MerbonDbVariable < handle

    properties(SetAccess = private)
        Tags;
        Identifiers;
    end
    properties(SetAccess = public)
        Label;
    end
    
    methods
        function this = MerbonDbVariable(varDef,label,tags)                  
            if(~isempty(varDef))
                if(nargin<2)
                     this.Tags = [];
                     name = '';
                     for n=1:size(varDef,1)
                         row = strcat([varDef{n,1},'-',varDef{n,2}]);
                         if(n==1)
                             name = row;
                         else
                             name = strcat([name,'  ',row]);
                         end
                     end
                     this.Label = name;
                elseif(nargin<3)
                    this.Label = label;
                    this.Tags = [];
                else
                    this.Label = label;
                    this.Tags = tags;
                end
                if(size(varDef,2)==2)
                    l = size(varDef,1);
                    def = cell(l,3);
                    def(1:end,:) = [varDef(:,1),varDef(:,2),num2cell(ones(l,1))];
                    this.Identifiers = def;
                elseif(size(varDef,2)==3)
                    this.Identifiers = varDef;
                end
            else
                this.Identifiers = {};
                this.Tags = [];
                this.Label = 'empty variable';
            end
        end
        
        function setKeyKey(this,IDs,keyValues)
           lt = size(IDs,1);
           lv = size(keyValues,1);
           if(lt~=lv)
               error(' Incorrect matrices dimensions');
           end
           validKeyValues = find(keyValues~=0 & keyValues~=1, 1);
           if(~isempty(validKeyValues))
              error('Incorrect keyValue. Other value then 0 or 1 is not alowed.'); 
           end
           actVar = this.Identifiers;
           if(~isempty(actVar))
               for tag=1:lt
                   ind = find(strcmp(actVar(:,1),IDs{tag}));
                   if(isempty(ind))
                       warning('Identifier %s was not found',IDs{tag});
                   else
                       actVar(ind,3) = {keyValues(tag)};
                   end
               end
           end
           this.Identifiers = actVar;
        end        
        
        function setIdentifiers(this,varDef)
           this.Identifiers = varDef;
        end   
        
        function idKey =  getIdentifierKey(this, name)
            def = this.Identifiers;
            ids = def(:,1);
            keys = def(:,2);
            ind = strcmp(ids, name);
            idKey = keys(ind);
        end
        
        function deleteKey(this, key)
            def = this.Identifiers;
            ids = def(:,1); 
            ind = strcmp(ids, {key});
%             def(ind,:)  = [];
            this.Identifiers(ind,:) = [];
%             var = MerbonDbVariable(def);
        end
    end
    
end

