function [utcMatlabTime] = localMatlab2utcMatlab(localMatlabTime,timeZoneID)

import java.lang.String
import java.util.* java.awt.*
import java.util.Enumeration

if(nargin < 2)
    timeZone = TimeZone.getDefault();
    timeZoneID = timeZone.getID();
end

% filepath = fullfile(matlabroot,'toolbox','matlab','timefun','@datetime','datetime.m');
matlabVersion  = version('-release');
[matlabYear,~,~] = datevec(datenum(version('-date')));

% if(exist(filepath, 'file') == 2)
if(strcmp(matlabVersion,'2014b') || matlabYear > 2014)
    [Y,M,D,H,m,s] = datevec(localMatlabTime);
    utcMatTimes = datetime(Y',M',D',H',m',s','TimeZone','utc');
    localMatTimes = datetime(Y',M',D',H',m',s','TimeZone',char(timeZoneID));

    [offsets,~,~] = hms(utcMatTimes - localMatTimes);
else
    t1 = GregorianCalendar(TimeZone.getTimeZone(timeZoneID));
    len = length(localMatlabTime);
    offsets = zeros(len,1);
    for t = 1:len
        [Y,M,D,H,m,s] = datevec(localMatlabTime(t));
        t1.set(Y,M-1,D,H,m,s);
        offset =((t1.get(t1.ZONE_OFFSET) + t1.get(t1.DST_OFFSET))/(60 * 1000))/60;
        offsets(t) = offset;
    end
end

if(isrow(localMatlabTime))
    utcMatlabTime = (localMatlabTime'-datenum(0,0,0,offsets,0,0));
else
    utcMatlabTime = (localMatlabTime-datenum(0,0,0,offsets,0,0));
end


end

