function [matlabTime,unInds,matlab_interp_time_axis] = unixUtc2localMatlab(utcTime,timeZoneID)

% l = length(utcTime);
% matlabTime = zeros(l,1);

if(isrow(utcTime))
    utcTime = utcTime';
end

if(isempty(utcTime))
    matlabTime = [];
    unInds = [];
    return;
end

import java.lang.String
import java.util.* java.awt.*
import java.util.Enumeration

if(nargin<2)
    timeZone = TimeZone.getDefault();
    timeZoneID = timeZone.getID();
end

matlabVersion  = version('-release');
[matlabYear,~,~] = datevec(datenum(version('-date')));


if(strcmp(matlabVersion,'2014b') || matlabYear > 2014)
    matlabTimes = unix2matlab(utcTime);
    [Y,M,D,H,m,s] = datevec(matlabTimes);
    utcMatTimes = datetime(Y',M',D',H',m',s','TimeZone','utc');
    localMatTimes = datetime(Y',M',D',H',m',s','TimeZone',char(timeZoneID));

    [offsets,~,~] = hms(utcMatTimes - localMatTimes);
else
    t2 = GregorianCalendar(TimeZone.getTimeZone(timeZoneID));
    offsets = zeros(1,length(utcTime));
    for t=1:length(utcTime)
        [Y,M,D,H,m,s] = datevec(unix2matlab(utcTime(t)));
        t2.set(Y,M-1,D,H,m,s);
        offset =((t2.get(t2.ZONE_OFFSET) + t2.get(t2.DST_OFFSET))/(60 * 1000))/60;
        offsets(t) = offset;
    end
end

m_time = datetime(utcTime,'ConvertFrom','posixtime');
matlabTime = datenum(m_time + hours(offsets)');

%%old eval - for versions 2014a and less
% matlabTime = ((round(utcTime*1000)/8.64e7)+datenum('1970', 'yyyy'))'  + datenum(0,0,0,offsets,0,0)';

unixTimeLocal = int64(matlab2unix(matlabTime));
[~,unInds,~] = unique(unixTimeLocal);
unix_sample = median(diff(double(unixTimeLocal)));
new_unix_time = double(unixTimeLocal(1)):unix_sample:double(unixTimeLocal(end));

matlab_interp_time_axis = unix2matlab(new_unix_time');
matlabTime = matlabTime(unInds);

end

